**THIS CODE IS VERY POOR QUALITY. I DO NOT RECOMMEND ATTEMPTING TO BUILD ON-TOP OF IT. IT WILL BE SEVERELY REFACTORED FOR TIDINESS AND MAINTENABILITY IN FUTURE PENDING FEEDBACK ON VIABILITY OF THE GENERAL CONCEPT**

Should be re-written in Typescript too.
